<?php
namespace App\modele;
class UtilisateurModele
{
    /**
     * @description Charger le flux d'activiter
     * @return array flux
     */
    public function LoadFeed() : array
    {
        // TO DO
        return [];
    }

    /**
     * @description se connecter
     * @param string email
     * @param string hash
     * @return \App\metier\Alumni
     */
    public function connection(string $email, string $hash) : ? \App\metier\Alumni
    {
        $dsn = "mysql:host=localhost;dbname=dbAlica";
        $username = "Dev";
        $password = "Dev";

        $con = new \App\gateway\Connection($dsn, $username, $password);
        $gate = new \App\gateway\AlumniGateway($con);
        // Récupérez l'utilisateur avec l'email donné en utilisant AlumniGateway
        $utilisateur = $gate->findByEmail($email);
        if ($utilisateur instanceof \App\metier\Alumni) {
            // L'utilisateur existe, vérifiez le mot de passe
            if ($hash==$utilisateur->getPassword()) {
                // Le mot de passe est correct, retournez l'utilisateur
                session_start();
                return $utilisateur;
            } else {
                // Le mot de passe est incorrect, renvoyez null
                return null;
            }
        } else {
            // L'utilisateur n'existe pas, renvoyez null
            return null;
        }
    }

    /**
     * @description s'inscrire
     * @param string email
     * @param string hash
     * @param string $pseudo
     * @return \Alumni chargé
     */
    public function inscription(string $email, string $hashpassword): \App\metier\Alumni
    {
        $dsn = "mysql:host=localhost;dbname=dbAlica";
        $username = "Dev";
        $password = "Dev";

        $role = "Membre";
        $con = new \App\gateway\Connection($dsn, $username, $password);
        $gate = new \App\gateway\AlumniGateway($con);
        // Insérez le nouvel utilisateur dans la base de données en utilisant AlumniGateway
        if ($gate->insert($email, $hashpassword, $role)) {
            // L'insertion a réussi, retournez le nouvel utilisateur
            $nouvelUtilisateur = new \App\metier\Alumni($email, $hashpassword, $role);
            return $nouvelUtilisateur;
        } else {
            // L'insertion a échoué, renvoyez un utilisateur vide pour indiquer l'échec
            return new \App\metier\Alumni(null, null,  null);
        }
    }

    public function getUtilisateurByEmail(string $email)
    {
        $dsn = "mysql:host=localhost;dbname=dbAlica";
        $username = "Dev";
        $password = "Dev";

        $con = new \App\gateway\Connection($dsn, $username, $password);
        $gate = new \App\gateway\AlumniGateway($con);
        // Récupérez l'utilisateur avec l'email donné en utilisant AlumniGateway
        $utilisateur = $gate->findByEmail($email);
        if ($utilisateur instanceof \App\metier\Alumni) {
            // L'utilisateur existe, retournez-le
            return $utilisateur;
        } else {
            // L'utilisateur n'existe pas, renvoyez null
            return null;
        }
    }
}
